#!/usr/bin/python3

def rotateCW(data):
  data1 = []
  for y in range(len(data[0])):
    data1.append([])
    for x in range(len(data)):
      data1[y].append(data[x][-y-1])
  return data1

def rotateCC(data):
  data1 = []
  for y in range(len(data[0])):
    data1.append([])
    for x in range(len(data)):
      data1[y].append(data[-x-1][y])
  return data1

def rotateH(data):
  data1 = []
  for y in range(len(data)):
    data1.append([])
    for x in range(len(data[0])):
      data1[y].append(data[-y-1][-x-1])
  return data1

tsstart,tsend,cimage = [int(i) for i in input().split()] 
images = []
for _ in range(cimage):
  images.append([])
  images[-1] += [int(i) for i in input().split()]
  images[-1].append([])
  for _ in range(images[-1][1]):
    images[-1][3].append([int(i) for i in input().split()])

for img in images:
  ''' sum '''
  img.append(sum([sum(i) for i in img[3]]))
  ''' shape '''
  img.append([])
  miny = img[1]
  minx = img[2]
  maxy = 0
  maxx = 0
  for y in range(img[1]):
    for x in range(img[2]):
      if img[3][y][x] > 0:
        maxy = max(maxy,y)
        maxx = max(maxx,x)
        miny = min(miny,y)
        minx = min(minx,x)
  for y in range(miny,maxy+1):
    img[5].append([int(i>0) for i in img[3][y][minx:maxx+1]])

''' IMAGES -> ASTEROIDS (shapes) '''
asteroids = []
for img in images:
  if img[4] != 0:  
    if img[5] in [i[0] for i in asteroids]:
      asteroids[[i[0] for i in asteroids].index(img[5])][1].append([img[0],0])
    elif rotateCW(img[5]) in [i[0] for i in asteroids]:
      asteroids[[i[0] for i in asteroids].index(rotateCW(img[5]))][1].append([img[0],1])
    elif rotateCC(img[5]) in [i[0] for i in asteroids]:
      asteroids[[i[0] for i in asteroids].index(rotateCC(img[5]))][1].append([img[0],3])
    elif rotateH(img[5]) in [i[0] for i in asteroids]:
      asteroids[[i[0] for i in asteroids].index(rotateH(img[5]))][1].append([img[0],2])
    else:
      asteroids.append([img[5],[[img[0],0]]])

''' for each ASTEROID (shape) '''
for ast in asteroids:
  ast.append([])
  for occ in range(len(ast[1])):
    for i in range(occ+1,len(ast[1])):
      if not True in [ast[1][occ][0] in ii or ast[1][i][0] in ii for ii in ast[2]]:
        period = ast[1][i][0]-ast[1][occ][0]
        perrot = ast[1][i][1]-ast[1][occ][1]
        if ast[1][occ][0]+2*period in [ii[0] for ii in ast[1]] and ast[1][occ][0]+3*period in [ii[0] for ii in ast[1]]:
          ast[2].append([])
          x = 0
          while ast[1][occ][0]+x*period in [i[0] for i in ast[1]] and (ast[1][occ][1]+x*perrot)%4 == ast[1][[i[0] for i in ast[1]].index(ast[1][occ][0]+x*period)][1]:
            ast[2][-1].append(ast[1][occ][0]+x*period)
            x += 1
          if not (ast[2][-1][0]-period < tsstart and ast[2][-1][-1]+period > tsend):
            del ast[2][-1]
          else:
            break
  
out = {}
for ast in asteroids:
  for ser in ast[2]:
    if ser[0]-(ser[1]-ser[0]) < tsstart and ser[-1]+(ser[1]-ser[0]) > tsend:
      out[ser[0]] = [ser[0],ser[-1],len(ser)]

for o in sorted(out.keys()):
  print(" ".join([str(i) for i in out[o]]))
